# coding: utf-8
"""

    ReadOnlyText.py

    Copyright (c) 2018, Masatsuyo Takahashi, KEK-PF

"""
import tkinter      as Tk

def txtEvent(event):
    """
    https://stackoverflow.com/questions/3842155/is-there-a-way-to-make-the-tkinter-text-widget-read-only
    """
    # print( 'txtEvent:', event.state, event.keysym )
    # if(event.state==12 and event.keysym=='c' ):
    if( event.state==4 and event.keysym=='c' ):     # depending on keyboard setting?
        return
    else:
        return "break"

class ReadOnlyText(Tk.Text):
    def __init__( self, *args, **kwargs ):
        Tk.Text.__init__( self, *args, **kwargs )
        self.bind("<Key>", lambda e: txtEvent(e) )  # to make it read-only

class CopyableLabel(ReadOnlyText):
    def __init__( self, parent, text, *args, **kwargs ):
        ReadOnlyText.__init__( self, parent, *args, **kwargs )
        self.insert( Tk.END, text )
        lable = Tk.Label( parent )
        bg = lable.cget( 'bg' )
        self.config( relief=Tk.FLAT, height=1, width=len(text), bg=bg )

    def config( self, text=None, *args, **kwargs ):
        if text is not None:
            self.delete( '1.0', Tk.END )
            self.insert( Tk.END, text )
            self.config( width=len(text) )
        ReadOnlyText.config( self, *args, **kwargs )
